/* matrix.h
 * erstellt: Die Okt 26 16:21:25 CEST 1999
 * Autoren : Mirko Belickin und Joachim Wagner
 */

#ifndef __MATRIX_H
#define __MATRIX_H

#include <stdio.h>

typedef struct matrixFunktionen matrixFunktionen;

typedef struct matrix {
    matrixFunktionen *aktion;
    void *daten;
} matrix;


/* Makros, die die Benutzung vereinfachen */

#define AKTION3(m,a,x1,x2,x3)    (m)->aktion->a##((m),x1,x2,x3)
#define AKTION2(m,a,x1,x2)       (m)->aktion->a##((m),x1,x2)
#define AKTION1(m,a,x1)          (m)->aktion->a##((m),x1)
#define AKTION0(m,a)             (m)->aktion->a##(m)


struct matrixFunktionen {
    matrix  * (* laden)(FILE *datei, void *vater);
    int (* speichern)(matrix *m, FILE *datei);
    int (* freigeben)(matrix *m, void *vater);
    matrix  * (* kreieren)(void *schablone, void *vater);
    double (* amIndex)(matrix *m, int zeile, int spalte);
    void (* setzen)(matrix *m, int zeile, int spalte, double d); 
    int (* breite)(matrix *m);
    int (* hoehe)(matrix *m);
    matrix * (* produkt)(matrix *a, matrix *b);
};


typedef struct vektor2d {
  int x,y;
} vektor2d;

#endif

